﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGTemplateHierarchyCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }
        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < 3; i++)
            {
                Data.Add(new SampleData()
                {
                    Label = "Label " +i.ToString(),
                    Number = r.Next(10000)
                });
            }
        }
    }

    public class SampleData : BaseClass
    {
        private string L;
        public string Label
        {
            get { return L; }
            set
            {
                if (L != value)
                {
                    L = value;
                    OnPropertyChanged("Label");
                }
            }
        }

        public int Number { get; set; }

        public ObservableCollection<ChildData> Children { get; set; }

        Random r = new Random();
        public SampleData()
        {
            Children = new ObservableCollection<ChildData>();

            for (int i = 1; i <= 200; i++)
            {
                Children.Add(new ChildData()
                {                    
                    AllOne = r.Next(0,2),
                    AllTwo = r.Next(0, 2),
                    AllThree = r.Next(0, 2),
                });
            }
        }
    }

    public class ChildData : BaseClass
    {
        private int a1;
        private int a2;
        private int a3;
        private string aaa;

        public string AllAllAll
        {
            get { return aaa; }
            set
            {
                if (aaa != value)
                {
                    aaa = value;
                    OnPropertyChanged("AllAllAll");
                }
            }
        }
        public int AllOne
        {
            get { return a1; }
            set
            {
                if (a1 != value)
                {
                    a1 = value;
                    OnPropertyChanged("AllOne");
                }
            }
        }

        public int AllTwo
        {
            get { return a2; }
            set
            {
                if (a2 != value)
                {
                    a2 = value;
                    OnPropertyChanged("AllTwo");
                }
            }
        }
        public int AllThree
        {
            get { return a3; }
            set
            {
                if (a3 != value)
                {
                    a3 = value;
                    OnPropertyChanged("AllThree");
                }
            }
        }
    }

    public class BaseClass : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
